import java.util.Arrays;

public class PersonForeignerTest {

	public static void print(Person[] pArray) {
		for (Person p : pArray) {
			System.out.println(p.getClass().getName() + " " + p);
		}
	}
	public static void main(String[] args) {
		Person[] pArray = new Person[5];
		pArray[0] = new Person("JAVA1", 2, 30, 40, Gender.FEMALE);
		pArray[1] = new Person("JAVA2", 1, 50, 20, Gender.MALE);
		pArray[2] = new Foreigner();
		pArray[3] = new Foreigner("JAVA4", 10, 70, 100, Gender.MALE, "Korea");
		pArray[4] = new Foreigner("JAVA5", 5, 40, 80, Gender.FEMALE, "China");
		
		Arrays.sort(pArray, null); // Comparable
		print(pArray);
		
		System.out.println("sort by age");
		Arrays.sort(pArray, Person.byAge); // Comparator
		print(pArray);
		
		System.out.println("sort by gender");
		Arrays.sort(pArray, Person.byGender); // Comparator
		print(pArray);
		
		System.out.println("sort by Foreigner country");
		Arrays.sort(pArray, Person.byCountry); // Comparator
		print(pArray);
		
	}

}
